<?php

namespace Drp\IOEngage\Providers;

use Drp\IOEngage\Facades\Token;
use Drp\IOEngage\TokenManager;
use Illuminate\Support\ServiceProvider;

class IOEngageServiceProvider extends ServiceProvider
{
    /** @var string */
    protected $root = __DIR__ . '/../..';

    /** @var array<string> */
    protected $tags = [
        'ioengage-integration',
    ];

    public function boot(): void
    {
        $this->publishes([
            "{$this->root}/config/ioengage.php" => config_path('ioengage.php'),
        ], $this->tags);
    }

    public function register(): void
    {
        $this->mergeConfigFrom("{$this->root}/config/ioengage.php", 'ioengage');

        $this->app->bind(Token::class, function () {
            return new TokenManager();
        });
    }
}
