<?php

namespace Drp\IOEngage;

class SearchParameters
{
    private static $map = [
        'first_name' => 'FirstName',
        'last_name' => 'LastName',
        'name' => 'Name',
        'email' => 'Email',
        'job_title' => 'JobTitle',
        'identifier' => 'OneKeyId',
        'company' => 'Company',
        'line_1' => 'Line1',
        'line_2' => 'Line2',
        'city' => 'City',
        'country' => 'Country',
        'postcode' => 'Postcode',
        'page' => 'Page',
        'per_page' => 'PerPage',
    ];

    public static function make(array $parameters, ?int $page = 1, ?int $perPage = 10): array
    {
        $parameters = array_merge([
            'country' => 'GB',
            'per_page' => $perPage,
            'page' => $page,
        ], $parameters);

        return self::prepareSearchParameters($parameters);
    }

    private static function prepareSearchParameters(array $parameters): array
    {
        return collect($parameters)
            ->filter()
            ->flatMap(function ($value, $key) {
                return [self::$map[$key] => $value];
            })
            ->flatMap(function ($value, $key) {
                return [trim($key) => trim($value)];
            })
            ->toArray();
    }
}
