<?php

namespace Drp\IOEngage;

use Drp\IOEngage\Resources\Delegate;
use EventPortal\Contracts\SearchResults as SearchResultsContract;
use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Support\Arr;

class SearchResults implements Arrayable, SearchResultsContract
{
    /** @var int */
    public $perPage = 0;

    /** @var int */
    public $currentPage = 0;

    /** @var int */
    public $totalPages = 0;

    /** @var int */
    public $totalResults = 0;

    /** @var \Illuminate\Support\Collection */
    public $delegates;

    public function __construct(array $attributes)
    {
        $this->perPage = Arr::get($attributes, 'PerPage');
        $this->currentPage = Arr::get($attributes, 'CurrentPage');
        $this->totalPages = Arr::get($attributes, 'TotalPages');
        $this->totalResults = Arr::get($attributes, 'TotalResults');
        $this->delegates = collect(Arr::get($attributes, 'Results'))
            ->map(function (array $delegate) {
                return new Delegate($delegate);
            });
    }

    public function toArray(): array
    {
        /** @var \Illuminate\Support\Collection $delegates */
        $delegates = $this->delegates->map->toArray();

        return [
            'per_page' => $this->perPage,
            'current_page' => $this->currentPage,
            'total_pages' => $this->totalPages,
            'total_results' => $this->totalResults,
            'delegates' => $delegates->toArray(),
        ];
    }
}
