<?php

namespace Drp\IOEngage;

use Illuminate\Support\Facades\Http;

class TokenManager
{
    public function get(): Token
    {
        $token = new Token(cache('ioengage_token', []));

        if ($token->isInvalid()) {
            $token = $this->getFreshToken();

            $this->cacheToken($token);
        }

        return $token;
    }

    private function getFreshToken(): Token
    {
        $response = Http::withHeaders(config('ioengage.authentication_headers', []))
            ->post(config('ioengage.endpoints.token'));

        return new Token(Response::handle($response));
    }

    private function cacheToken(Token $token): void
    {
        cache()->set('ioengage_token', $token->toArray());
    }
}
