<?php

namespace Drp\IOEngage\Tests;

use Drp\IOEngage\Providers\IOEngageServiceProvider;

class TestCase extends \Orchestra\Testbench\TestCase
{
    protected function getPackageProviders($app)
    {
        return [IOEngageServiceProvider::class];
    }



    /**
     * Define environment setup.
     *
     * @param  \Illuminate\Foundation\Application  $app
     * @return void
     */
    protected function getEnvironmentSetUp($app)
    {
        $app['config']->set('ioengage.authentication_headers', [
            'client_id' => 'CLIENT_ID',
            'client_secret' => 'CLIENT_SECRET',
            'grant_type' => 'CLIENT_CREDENTIALS',
        ]);

        $app['config']->set('ioengage.endpoints.token', 'token');
        $app['config']->set('ioengage.endpoints.search', 'search');
    }
}
